#include "camera.h"
#include <GL/glu.h>

	
pCamera creeCamera (	Vector eye, Vector look, Vector up,
                    	float angleOuverture,
			float rapportAspect,
			float planAvant,
			float planArriere) {

	pCamera c = (pCamera) malloc (sizeof(tCamera));
	
	c->angleOuverture = angleOuverture;
	c->rapportAspect = rapportAspect;
	c->planAvant = planAvant;
	c->planArriere = planArriere;
	
	positionCamera (c,eye,look,up);
	
	return c;
}


void positionCamera (pCamera c, Vector eye, Vector look, Vector up) {
	
	copyVector (eye,c->o);
	diffVector (look, eye, c->z);
	normalizeVector (c->z);
	sumVector (c->o,c->z,c->vise);
	crossProductVector (up, c->z, c->x);
	normalizeVector (c->x);
	crossProductVector (c->z, c->x, c->y);
}

void perspectiveCamera (pCamera c) {
	gluPerspective(	c->angleOuverture, c->rapportAspect,
			c->planAvant, c->planArriere);
}

void placeCamera (pCamera c) {
	gluLookAt (	c->o[0], c->o[1], c->o[2],
			c->vise[0], c->vise[1], c->vise[2],
			c->y[0],c->y[1],c->y[2]);
}


void avanceCamera (pCamera c, float pas) {
	Vector deptZ;
	
	multFloatVector (pas, c->z, deptZ);
	sumVector (c->o, deptZ, c->o);
	sumVector (c->vise, deptZ, c->vise);
}


void walkRotYCamera (pCamera c, float pas) {
	Vector deptX;

	multFloatVector(pas, c->x, deptX);
	sumVector(c->vise, deptX, c->vise);
	diffVector(c->vise, c->o, c->z);
	normalizeVector(c->z);
	sumVector(c->o,c->z,c->vise);
	crossProductVector(c->y,c->z,c->x);
}


void walkRotXCamera (pCamera c, float pas) {
	Vector deptY;

	multFloatVector(pas, c->y, deptY);
	sumVector(c->vise, deptY, c->vise);
	diffVector(c->vise, c->o, c->z);
	normalizeVector(c->z);
	sumVector(c->o,c->z,c->vise);
	crossProductVector(c->z,c->x,c->y);
}


void walkRotZCamera (pCamera c, float pas) {
	Vector deptX;
	Vector viseY;

	multFloatVector(pas, c->x, deptX);
	sumVector(c->o,c->y,viseY);
	sumVector(viseY, deptX, viseY);
	diffVector(viseY, c->o, c->y);
	normalizeVector(c->y);
	crossProductVector(c->y,c->z,c->x);
}


